#include <bits/stdc++.h>
using namespace std;

#ifndef DBG
//#define NDEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#define cn const
#define cauto cn auto
#define endl '\n'
#define FOR(i, from, to) for (int i = (from); i <= (to); ++i)
#define FORN(i, n) FOR(i, 0, (n) - 1)
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define X F
#define Y S
#define CONT(c) begin(c), end(c)
#define ARR(a, sz) (a), ((a) + (sz))

using ll = long long;
using ull = unsigned long long;
using uint = unsigned;

// find_by_order, order_of_key
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
template<typename Key>
using ordered_set = __gnu_pbds::tree<Key, __gnu_pbds::null_type, less<Key>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<typename Key, typename Value>
using ordered_map = __gnu_pbds::tree<Key, Value, less<Key>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<typename T>
 T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
}

template<int Modulo>
struct MOD {
    static cn int M = Modulo;
    uint x;
    MOD(int val = 0) : x(val) { assert(0 <= val && val < M); }

    MOD& operator +=(MOD r) {
        x += r.x;
        if (x >= M)
            x -= M;
        return *this;
    }
    friend operator+(MOD l, MOD r) { return l += r; }

    MOD& operator *=(MOD r) {
        x = (ll(x) * r.x) % M;
        return *this;
    }
    friend MOD operator*(MOD l, MOD r){ return l *= r; }

    MOD& operator -=(MOD r) {
        x -= r.x;
        if (x >= M)
            x += M;
        return *this;
    }
    friend operator-(MOD l, MOD r) { return l -= r; }

    friend MOD operator -(MOD a){
        if (a.x)
            return M - a.x;
        return 0;
    }

    friend ostream& operator <<(ostream& cout, MOD x){ return cout << x.x; }
    friend bool operator ==(MOD l, MOD r){ return l.x == r.x; }
    friend bool operator <(MOD l, MOD r){ return l.x < r.x; }
};

namespace std {
template<int Modulo>
struct hash<MOD<Modulo>> {
    size_t operator()(MOD<Modulo> a) const noexcept { return a.x; }
};
}

template<int M>
MOD<M> binpow(MOD<M> a, ll p)
{
    MOD<M> res = 1;
    while (p) {
        if (p & 1)
            res *= a;
        a *= a;
        p >>= 1;
    }
    return res;
}

// Code start here

void solve()
{
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto& [h, p] : v)
        cin >> p;
    for (auto& [h, p] : v)
        cin >> h;
    sort(CONT(v));
    bool bad = false;
    FORN(i, n) {
        auto [h_i, p_i] = v[i];
        if (h_i < p_i)
            bad = true;
        if (i) {
            auto [h_1, p_1] = v[i - 1];
            if (p_i < p_1)
                bad = true;
            if (h_i == h_1 && p_i != p_1)
                bad = true;
            if (h_i - p_i < h_1 - p_1)
                bad = true;
        }
    }
    cout << (bad ? -1 : v.back().F - v.back().S) << endl;
}

signed main()
{
#ifdef MY
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif // MY
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
}
