﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>
#include <bitset>

#define all(v) v.begin(),v.end()

using namespace std;
typedef long long ll;
const long long MOD = 1000000000 + 7;
const long long MAXN = 100000;

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(9);

#ifdef TEAM
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
}

ll gcd(ll x, ll y) {
    while (y) {
        x %= y;
        swap(x, y);
    }
    return x;
}

ll binpow(ll a, ll k, ll mod = 1e9 + 7) {
    ll res = 1;
    ll t = a;
    while (k) {
        if (k % 2)
            res = (res * t) % mod;
        t = (t * t) % mod;
        k /= 2;
    }
    return res;
}

ll rev(ll a, ll mod = MOD) {
    return binpow(a, mod - 2, mod);
}

/*
ll fact[MAXN];
ll revf[MAXN];
void prec() {
    ll c=1;
    fact[0] = 1;
    for (size_t i = 1; i < MAXN; ++i)
    {
        fact[i] = (fact[i - 1] * i)%MOD;
    }
    revf[MAXN - 1] = rev(fact[MAXN - 1]);
    for (int i = MAXN - 2; i >= 0; i--)
    {
        revf[i] = (revf[i + 1] * (i+1)) % MOD;
    }
}
*/

void solve() {
    ll n; cin >> n;
    ll m; cin >> m;
    ll f=0, r=0;
    ll a, b;
    for (size_t i = 0; i < m; i++)
    {
        cin >> a >> b;
        if (a < b)
        {
            f++;
        }
        else {
            r++;
        }
    }
    if (f>r)
    {
        for (size_t i = 0; i < n; i++)
        {
            cout << i + 1 << " ";
        }
        cout << "\n";
    }
    else {
        for (int i = n - 1; i >= 0; i--)
        {
            cout << i + 1 << " ";
        }
        cout << "\n";
    }
    
}

int main()
{
    
    start();
    ll t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
