﻿#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using ll = long long;
using db = double;

using namespace std;

void solve() {
    string s;
    int n, inp;
    vector <int> arr;
    int ans = 2;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> s;
        inp = (s[0] - '0') * 60 + (s[2] - '0') * 10 + (s[3] - '0'); 
        arr.push_back(inp);
    }
    for (int l = 0; l < n; l++) {
        int r = l;
        while (r < n && arr[r] - arr[l] <= 10) {
            ans = min(ans, max(0, 2 - r + l));
            r++;
        }
    }
    cout << ans;
}

int main(){

#ifdef DEBUG
    auto f = freopen("test.txt", "r", stdin);
    cout << "Debug Mode" << endl;
#endif // DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();
}


