def solve(before, after, n):
    diffs = []
    for i in range(n):
        diffs.append(before[i][0] - after[before[i][1]])
        if i > 0 and before[i][0] == before[i - 1][0] and diffs[-1] != diffs[-2]:
            return -1

    for i in range(1, n):
        if diffs[i - 1] < diffs[i]:
            return -1

    return diffs[0]

ans = []
t = int(input())
for i in range(t):
    n = int(input())
    after = list(map(int, input().split()))
    before = list(map(int, input().split()))

    for i in range(len(before)):
        before[i] = (before[i], i)

    before.sort(reverse=True)
    ans.append(str(solve(before, after, n)))

print('\n'.join(ans))
