#include <iostream>
#include <queue>
#include <deque>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_set>

using namespace std;
int n, e;



int main(){
    cin >> n >> e;

    vector<string> buttons;
    for (int i = 0; i<n; ++i) {
        string tmp;
        cin >> tmp;
        buttons.push_back(tmp);
    }

    unordered_set<char> abc;
    for (int i = 0; i < e; ++i) {
        abc.insert('a' + i);
    }

    unordered_set<int> to_skip;
    for (int i = 0; i < n; ++i) {
        string b = buttons[i];
        bool flag = false;
        for (int j = 0; j < b.size()-1; ++j) {
            if (b[j] != b[j+1]) {
                flag = true;
                break;
            }
        }

        if (!flag) {
            abc.erase(b[0]);
            to_skip.insert(i);
        }
    }

    if (abc.size() == 0) {
        cout << "NO";
        return 0;
    }

    char ans;
    int len_ans = 1<<31-1;

    for (char letter : abc) {
        int cnt = 1;
        for (int i = 0; i < n; ++i) {
            if (to_skip.find(i) != to_skip.end()) {
                continue;
            }

            string b = buttons[i];
            for (int j=0; j<b.size(); ++j) {
                if (b[j] != letter) {
                    cnt += j;
                    break;
                }
            }
        }
        if (cnt < len_ans) {
            ans = letter;
            len_ans = cnt;
        }
    }

    for (int i = 0; i < len_ans; ++i) {
        cout << ans;
    }
    return 0;
}
