﻿
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <deque>
#include <stack>
#include <string>
#include <cstdint>

#define en '\n'
#define isz(x) int(x.size())
#define ins insert
#define pb push_back
#define str string
#define vec vector
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define fin(x) for (auto &it : x) cin >> it
#define fout(x) for (auto &it : x) cout << it << ' '; cout << en

using namespace std;
using ll = long long;
using ld = long double;
using i64 = int64_t;
using i32 = int32_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using V = vector<T>;
using vi = V<int>;
using vl = V<ll>;
using vpii = V<pii>;
using vpll = V<pll>;
using vld = V<ld>;
using vb = V<bool>;
using vc = V<char>;
using vs = V<str>;
using ull = unsigned long long;

template<typename T>
using pqsmalleststart = priority_queue<T, vector<T>, greater<T>>;

template<typename T>
using pqmaximumstart = priority_queue<T, vector<T>, less<T>>;


vec<vi> paths;
vec<vi> g;
vb used;

void dfs(int v) {
    paths.back().push_back(v);
    used[v] = true;

    for (auto& x : g[v])
        if (!used[x])
            dfs(x);
}

void solve() {
    int n, m; cin >> n >> m;

    paths = vec<vi>();
    g = vec<vi>(n + 1);
    used = vb(n + 1);

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
    }

    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            paths.push_back(vi());
            dfs(i);
        }
    }

    int cnt = paths.size() - 1;

    vi answer;
    for (int i = paths.size() - 1; i >= 0; i--) {
        cnt += paths[i].size() - 1;

        for (auto& x : paths[i])
            answer.push_back(x);
    }

    int m_ = m / 2;
    if (m & 1)
        m_++;

    if (cnt < m_) {
        cout << -1 << en;
        return;
    }

    fout(answer);
}

void multiSolve() {
    int t_; cin >> t_; while (t_--) {
        solve();
    }
}

void brute() {

}

void trash() {

}

int main()
{
    ios_base::sync_with_stdio(false);  cin.tie(0); cout.tie(0);
    //cout.setf(ios::fixed); cout.precision(20);

    //trash();
    //brute();
    //solve();
    multiSolve();
}