﻿// quarte.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

#define ll long long
#define all(x) x.begin(), x.end()
using namespace std;

ll minValue;

void dfs(int v, vector<bool>& used, vector<ll>& ans, vector<vector<ll>>& g)
{
	used[v] = true;
	for (int i = 0; i < g[v].size(); i++)
	{
		ll to = g[v][i];

		if (!used[to]) {
			dfs(to, used, ans, g);
		}
	}
	ans.push_back(v);
}

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		ll n, m;
		cin >> n >> m;
		vector<ll> ans(n);
		map<ll, ll> index;
		vector<pair<ll, ll>> ms;

		for (int i = 0; i < n; i++) {
			ans[i] = i;
			index[i] = i;
		}
		for (int i = 0; i < m; i++)
		{
			ll u, v;
			cin >> u >> v;
			u--; v--;
			ms.push_back({ u,v });
		}

		ll countWrong = 0;

		for (auto item : ms)
		{
			if (index[item.second] < index[item.first]) countWrong++;
		}

		if (countWrong * 2 > m)
			reverse(all(ans));

		for (int i = 0; i < n; i++) {
			cout << (ans[i] + 1) << " ";
		}

		cout << endl;
	}
}