#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

vector<long long> h;
vector<long long> p;

bool comp(pair<long long, long long> p1, pair<long long, long long> p2){
    long long i1 = p1.second;
    long long i2 = p2.second;
    return p[i1] < p[i2] || (p[i1] == p[i2] && (p[i1] - h[i1] < p[i2] - h[i2]));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long t;
    cin >> t;
    for(long long iii = 0; iii < t; iii++){
        long long n;
        cin >> n;
        set<long long> min;

        h = vector<long long> (n, 0);
        p = vector<long long> (n, 0);
        for(long long i = 0; i < n; i++){
            cin >> h[i];
        }
        for(long long i = 0; i < n; i++){
            cin >> p[i];
        }
        vector<pair<long long, long long>> v1(n);
        for (long long i = 0; i < n; ++i) {
            v1[i] = make_pair(p[i], i);
        }
       /* vector<pair<long long, long long>> v2(n);
        for (long long i = 0; i < n; ++i) {
            v2[i] = make_pair(p[i] - h[i], i);
        }*/
        //sort(v2.begin(), v2.end());
        sort(v1.begin(), v1.end(), comp);
        long long ans = 0;
        for (int i = 0; i < n; ++i) {
            int now = v1[i].first - ans;
            if(now < h[v1[i].second]){
                ans = -1;
                break;
            }
            ans += (now - h[v1[i].second]);
        }
        cout << ans << endl;
        /*bool tr = true;
        for (long long i = 0; i < n; ++i) {
            if (v1[i].second != v2[i].second || v2[i].first < 0) tr = false;
        }
        if (tr) {
            cout << v2.back().first << endl;
        } else {
            cout << -1 << endl;
        }*/
    }
}
