#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

vector<long long> h;
vector<long long> p;

bool comp(pair<long long, long long> p1, pair<long long, long long> p2){
    long long i1 = p1.second;
    long long i2 = p2.second;
    return h[i1] < h[i2] || (h[i1] == h[i2] && (p[i1] - h[i1] < p[i2] - h[i2]));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long t;
    cin >> t;
    for(long long iii = 0; iii < t; iii++){
        long long n;
        cin >> n;
        set<long long> min;

        h = vector<long long> (n, 0);
        p = vector<long long> (n, 0);
        for(long long i = 0; i < n; i++){
            cin >> h[i];
        }
        for(long long i = 0; i < n; i++){
            cin >> p[i];
        }
        vector<pair<long long, long long>> v1(n);
        for (long long i = 0; i < n; ++i) {
            v1[i] = make_pair(p[i], i);
        }
        vector<long long> d(n);
        for (int i = 0; i < n; ++i) {
            d[i] = p[i] - h[i];
        }

        vector<pair<long long, long long>> v2(n);
        sort(v1.begin(), v1.end(), comp);
        for (int i = 0; i < n; ++i) {
            v2[i] = make_pair(d[v1[i].second], i);
        }
        int cur = -1;
        bool f  =false;
        for (int i = 0; i < n; ++i) {
            if (cur > v2[i].first) {
                cout << -1 << endl;
                f = true;
                break;
            } else {
                cur = v2[i].first;
            }
        }
        if (f) continue;
        cout << cur << endl;
    }
}