#include<iostream>
#include<fstream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<queue>
#include<stack>
#include<set>
#include<map>

using namespace std;
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;

    for (ll i = 0; i < t; ++i)
    {
        ll n;
        cin >> n;
        vector<pair<ll,ll>> R, B;
        ll Rn = 0, Bn = 0;
        for (ll j = 0; j < n; ++j)
        {
            ll a, b;
            char p;
            cin >> a >> b >> p;
            if (p == 'R')
            {
                R.push_back({ a,b });
                Rn += b;
            }
            else
            {
                B.push_back({ a,b });
                Bn += b;
            }
        }
        if (Rn == Bn)
        {
            cout << "Draw 0 0\n";
            continue;
        }
        if (Rn > Bn)
        {
            if (R.back().first < B.back().first)
            {
                if ((R.back().first + 1 < B.back().first) ||
                    (R.back().first + 1 == B.back().first && B.back().second > 1))
                {
                    cout << "Draw 0 0\n";
                }
                else if (R.back().first + 1 == B.back().first && B.back().second == 1)
                {
                    ll temp = R.back().first;
                    if (R.back().second > 1 || Bn == 1)
                        cout << "First " << temp << " +\n";
                    else {
                        R.pop_back();
                        B.pop_back();
                        if (R.back().first < B.back().first)
                            cout << "Draw 0 0\n";
                        else
                            cout << "First " << temp << " +\n";
                    }
                }
            }
            else
            {
                cout << "First 0 0\n";
            }

            continue;
        }
        if (Rn < Bn)
        {
            if (R.back().first > B.back().first)
                cout << "Draw " << R.back().first << " +\n";
            else
                cout << "Second\n";
            continue;
        }
    }

    return 0;
}