#include <bits/stdc++.h>
using namespace std;

#ifndef DBG
//#define NDEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#define cn const
#define cauto cn auto
#define endl '\n'
#define FOR(i, from, to) for (int i = (from); i <= (to); ++i)
#define FORN(i, n) FOR(i, 0, (n) - 1)
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define X F
#define Y S
#define CONT(c) begin(c), end(c)
#define ARR(a, sz) (a), ((a) + (sz))

using ll = long long;
using ull = unsigned long long;
using uint = unsigned;

// find_by_order, order_of_key
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
template<typename Key>
using ordered_set = __gnu_pbds::tree<Key, __gnu_pbds::null_type, less<Key>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<typename Key, typename Value>
using ordered_map = __gnu_pbds::tree<Key, Value, less<Key>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<typename T>
 T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
}

template<int Modulo>
struct MOD {
    static cn int M = Modulo;
    uint x;
    MOD(int val = 0) : x(val) { assert(0 <= val && val < M); }

    MOD& operator +=(MOD r) {
        x += r.x;
        if (x >= M)
            x -= M;
        return *this;
    }
    friend MOD operator+(MOD l, MOD r) { return l += r; }

    MOD& operator *=(MOD r) {
        x = (ll(x) * r.x) % M;
        return *this;
    }
    friend MOD operator*(MOD l, MOD r){ return l *= r; }

    MOD& operator -=(MOD r) {
        x -= r.x;
        if (x >= M)
            x += M;
        return *this;
    }
    friend MOD operator-(MOD l, MOD r) { return l -= r; }

    friend MOD operator -(MOD a){
        if (a.x)
            return M - a.x;
        return 0;
    }

    friend ostream& operator <<(ostream& cout, MOD x){ return cout << x.x; }
    friend istream& operator >>(istream& cin, MOD& x){ return cin >> x.x; }
    friend bool operator ==(MOD l, MOD r){ return l.x == r.x; }
    friend bool operator <(MOD l, MOD r){ return l.x < r.x; }
};

namespace std {
template<int Modulo>
struct hash<MOD<Modulo>> {
    size_t operator()(MOD<Modulo> a) const noexcept { return a.x; }
};
}

template<int M>
MOD<M> binpow(MOD<M> a, ll p)
{
    MOD<M> res = 1;
    while (p) {
        if (p & 1)
            res *= a;
        a *= a;
        p >>= 1;
    }
    return res;
}

// Code start here

using Mod = MOD<998'244'353>;

Mod binpow(Mod a, ll p)
{
    Mod res = 1;
    while (p) {
        if (p & 1)
            res *= a;
        a *= a;
        p >>= 1;
    }
    return res;
}

void precalc()
{
}

Mod k;

Mod f(int n)
{
    assert(n >= 0);
    if (n == 0)
        return 1;
    if (k.x == 2) {
        if (n & 1)
            return 0;
        return 1;
    }
    Mod q = -(k - 1), b0 = k - 1;
    Mod inv_q = binpow(q - 1, Mod::M - 2);
    Mod geom_sum = b0 * (binpow(q, n) - 1) * inv_q;
    if (n & 1)
        return geom_sum - 1;
    return -geom_sum + 1;
}

int n;

struct Segment {
    int start, finish, len;
    Segment(int start, int finish) : start(start), finish(finish) {
        assert(start != finish);
        if (start < finish)
            len = finish - start;
        else
            len = (n - start) + (finish - 1);
    }
    friend bool operator <(cn Segment& a, cn Segment& b) {
        return a.len < b.len;
    }
};

void solve()
{
    int m;
    cin >> n >> m >> k;

    if (m == 0) {
        cout << k * (k - 1) * f(n - 2) << endl;
        return;
    }
    vector<Segment> segments;
    vector<int> real_vertices;
    FORN(i, m) {
        int u, v;
        cin >> u >> v;
        real_vertices.pb(u);
        real_vertices.pb(v);
        segments.emplace_back(u, v);
        segments.emplace_back(v, u);
    }
    sort(CONT(segments));
    sort(CONT(real_vertices));
    real_vertices.resize(unique(CONT(real_vertices)) - begin(real_vertices));
    assert(real_vertices.size() >= 2);
    Mod ans = k * (k - 1);
    map<int, int> s;
    for (int i = 0; i + 1 < real_vertices.size(); ++i) {
        s.emplace(real_vertices[i], 1);
        int len = real_vertices[i + 1] - real_vertices[i] - 1;
        if (len)
            s.emplace(real_vertices[i] + 1, len);
    }
    s.emplace(real_vertices.back(), 1);
    int last_len = (n - real_vertices.back()) + (real_vertices[0] - 1);
    if (last_len)
        s.emplace(0, last_len);
    for (auto [from, to, _] : segments) {
        auto it = s.find(from);
        if (it == s.end())
            continue;
        auto it2 = s.find(to);
        if (it2 == s.end())
            continue;
        int cnt = 0;
        auto it3 = next(it);
        while (it3 != s.end() && it3 != it2) {
            cnt += it3->S;
            s.erase(it3++);
        }
        if (it3 == s.end()) {
            it3 = s.begin();
            while (it3 != s.end() && it3 != it2) {
                cnt += it3->S;
                s.erase(it3++);
            }
        }
        ans *= f(cnt);
    }
    cout << ans << endl;
}

signed main()
{
#ifdef MY
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif // MY
    precalc();
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
}
