﻿#pragma warning(disable : 4996)
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <queue>
#include <list>
#include <stack>
#include <fstream>
#include <sstream>
#include <functional>
#include <climits>

#define all(t) t.begin(), t.end()
#define ll long long
#define ull unsigned long long
#define ld long double
#define ainb(a, b) (b.find(a) != b.end())
#define vll vector<ll>
#define vec vector
#define cll(cll_i) ll cll_i; cin >> cll_i;
#define pll pair<ll, ll>
#define vpl vec<pll>
#define invll(invec_v, invec_n) vll invec_v(invec_n); for (ll &invec_i : invec_v) cin >> invec_i;
#define outvec(outvec_v) for (auto &outvec_i : outvec_v) cout << outvec_i << " "; cout << '\n';
#define sqr(x) (x) * (x)
#define FOR(FOR_I, FOR_END) for (ll FOR_I = 0; FOR_I < FOR_END; FOR_I++)
#define FE(FOR_I, ITERABLE) for (auto &FOR_I : ITERABLE)
#define FEC(FOR_I, ITERABLE) for (const auto &FOR_I : ITERABLE)
using namespace std;

void solve()
{
    cll(n);
    invll(as, n);

    ll mnm = as[0];
    FE(a, as) mnm = min(mnm, a);
    ll start = -1;
    for (ll i = 0; i < n; i++)
    {
        if (as[i] == mnm)
        {
            start = i;
            break;
        }
    }

    for (ll res = mnm; res >= max(0ll, mnm - 2); res--)
    {
        for (ll uses = 0; uses < 2; uses++)
        {
            if (mnm - 2 * uses < res)
            {
                continue;
            }
            bool ok = true;
            ll uprimes = mnm - uses * 2 - res;
            ll i = (start + 1) % n;
            while (i != start)
            {
                ll aprime = as[i] - 2 * uprimes;
                uprimes = aprime - res;
                if (uprimes < 0)
                {
                    ok = false;
                    break;
                }
                i = (i + 1) % n;
            }
            
            if (ok && uprimes == uses)
            {
                cout << res << '\n';
                return;
            }
        }
    }

    cout << "0\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG

    ll t = 1;
    cin >> t;
    while (t--) solve();

    return 0;
}
