#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

map <int, int> g;
set <pair <int, int>> mnoj;
vector <vector <int>> graph;


int main()
{
    int t, n, m, x, y;

    cin >> t;

    for (int i = 0; i < t; i++) {
        mnoj.clear();
        g.clear();
        graph.clear();

        cin >> n >> m;
        int cnt = 0;
        graph.resize(n + 2);
        for (int j = 0; j < m; j++) {
            cin >> x >> y;
            if (x < y) {
                cnt++;
            }
            g[x]++;
            graph[y].push_back(x);
        }

        for (int j = 1; j <= n; j++) {
            if (g.count(j) == 0) {
                g[j] = 0;
            }
            mnoj.insert({g[j], j});
        }



        for (int j = 0; j < n; j++) {
            pair <int, int> vertex = *mnoj.rbegin();
            mnoj.erase(vertex);


            cout << vertex.second << ' ';

            for (auto k : graph[vertex.second]) {
                if (mnoj.count({g[k], k})) {
                    mnoj.erase({g[k], k});
                    g[k]--;
                    mnoj.insert({g[k], k});
                }
            }
        }

        cout << endl;
    }

    return 0;
}
