#include <iostream>
#include <random>
#include <vector>
#include <algorithm>

using namespace std;

vector <int> permutations;
vector <pair <int, int>> edges;
vector <int> elems;

int main()
{
    int t, n, m, x, y;

    cin >> t;

    for (int i = 0; i < t; i++) {
        permutations.clear();
        edges.clear();
        elems.clear();

        cin >> n >> m;

        for (int j = 0; j < m; j++) {
            cin >> x >> y;

            edges.push_back({x, y});
        }

        for (int j = 1; j <= n; j++) {
            permutations.push_back(j);
        }
        elems.resize(n + 1);

        while (true) {
            random_shuffle(permutations.begin(), permutations.end());

            for (int j = 0; j < permutations.size(); j++) {
                elems[permutations[j]] = j + 1;
            }

            int c = 0;
            for (int j = 0; j < m; j++) {
                if (elems[edges[j].first] < elems[edges[j].second]) {
                    c++;
                }
            }

            if (c >= m / 2 + m % 2) {
                break;
            }
        }

        for (auto j : permutations) {
            cout << j << ' ';
        }
        cout << endl;
    }

    return 0;
}
