from collections import Counter
from math import ceil

t = int(input())

for _ in range(t):
    n, m = map(int, input().split())

    g = Counter()
    d = Counter()

    edges = []

    for _ in range(m):
        u, v = map(int, input().split())
        g[u] += 1
        d[v] += 1
        edges.append((u, v))

    result = sorted(range(1, n + 1), key=lambda x: (-g[x], d[x]))
    
    dictt = {}
    for i, e in enumerate(result):
        dictt[e] = i

    cnt = 0
    for u, v in edges:
        if dictt[u] < dictt[v]:
            cnt += 1

    if cnt < ceil(m / 2):
        print(-1)
        continue

    for e in result:
        print(e, end=' ')
    print()