﻿
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <deque>
#include <stack>
#include <string>
#include <cstdint>

#define en '\n'
#define isz(x) int(x.size())
#define ins insert
#define pb push_back
#define str string
#define vec vector
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define fin(x) for (auto &it : x) cin >> it
#define fout(x) for (auto &it : x) cout << it << ' '; cout << en

using namespace std;
using ll = long long;
using ld = long double;
using i64 = int64_t;
using i32 = int32_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using V = vector<T>;
using vi = V<int>;
using vl = V<ll>;
using vpii = V<pii>;
using vpll = V<pll>;
using vld = V<ld>;
using vb = V<bool>;
using vc = V<char>;
using vs = V<str>;
using ull = unsigned long long;

template<typename T>
using pqsmalleststart = priority_queue<T, vector<T>, greater<T>>;

template<typename T>
using pqmaximumstart = priority_queue<T, vector<T>, less<T>>;

void solve() {
    int n; cin >> n;
    vi to(n);
    vi from(n);
    fin(to); fin(from);
    map<int, int> mp;
    for (size_t i = 0; i < n; i++)
    {
        if (to[i] < from[i]) {
            cout << -1 << en;
            return;
        }
        mp[to[i]] = max(mp[to[i]], from[i]);
    }
    vpii v(all(mp));
    n = isz(v);
    int ans = -1;
    ll sumMinus = v[0].second - v[0].first;
    for (size_t i = 1; i < n; i++)
    {
        auto [to, from] = v[i];
        int d = from - to;
        if (d < sumMinus) {
            cout << -1 << en;
            return;
        }
        sumMinus += d - sumMinus;
    }
    cout << sumMinus << en;
}

void multiSolve() {
    int t_; cin >> t_; while (t_--) {
        solve();
    }
}

void brute() {

}

void trash() {

}

int main()
{
    ios_base::sync_with_stdio(false);  cin.tie(0); cout.tie(0);
    //cout.setf(ios::fixed); cout.precision(20);

    //trash();
    //brute();
    //solve();
    multiSolve();
}