#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>

using namespace std;

vector<unordered_set<int>> g;

bool comp(int a, int b) {
    return g[a].find(b) != g[a].end();
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int ktc;
    cin >> ktc;
    for (int i = 0; i < ktc; ++i) {
        int n, m;
        cin >> n >> m;
        g = vector<unordered_set<int>>(n);
        vector<pair<int, int>> e;
        for (int j = 0; j < m; ++j) {
            int a,b;
            cin >> a >> b;
            a--;b--;
            g[a].insert(b);
        }
        vector<int> v(n);
        for (int j = 0; j < n; ++j) {
            v[j] = j;
        }
        sort(v.begin(), v.end(), comp);
        for (int j = 0; j < n; ++j) {
            cout << v[j] + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}