﻿#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>

int main() {
    int64_t t;
    std::cin >> t;
    for (int64_t u = 0; u < t; ++u) {
        int64_t n;
        std::cin >> n;
        std::vector<int64_t> cur(n);
        for (int64_t& ci : cur)
            std::cin >> ci;
        std::vector<int64_t> prev(n);
        for (int64_t& pri : prev)
            std::cin >> pri;
        int64_t ans = 0;
        std::vector<std::pair<int64_t, int64_t>> pc(n);
        for (int64_t i = 0; i < n; ++i)
            pc[i] = { prev[i], cur[i] };
        std::sort(pc.begin(), pc.end());
        for (int64_t i = 0; i < n; ++i) {
            if (pc[i].first - ans < pc[i].second) {
                ans = -1;
                break;
            }
            else if (i > 0 && pc[i].first - pc[i - 1].first < pc[i].first - ans - pc[i].second) {
                ans = -1;
                break;
            } else
                ans += (pc[i].first - ans - pc[i].second);

        }
        std::cout << ans << '\n';
    }
    return 0;
}