﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <unordered_map>

#define ll long long;
#define all(x) (x).begin(), (x).end()

using namespace std;

vector<int> ans;
vector<char> used;
vector<vector<int>> edge;

void dfs(int v) {
    used[v] = 1;
    for (int u : edge[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    ans.push_back(v);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        edge.clear();
        edge.resize(n);
        used.assign(n, 0);
        ans.clear();
        for (int i = 0; i < m; i++) {
            int u, v; cin >> u >> v;
            u--; v--;
            edge[u].push_back(v);
        }
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        reverse(all(ans));
        for (int v : ans) {
            cout << v + 1 << " ";
        }
        cout << "\n";

    }
}