﻿#include <iostream>
#include <map>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <string>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	int n, e;
	vector<string> keys;
	cin >> n >> e;
	set<char> bad_chrs;
	for (int i = 0; i < n; i++) {
		keys.push_back({});
		cin >> keys.back();
		bool q = 1;
		for (char chr : keys.back()) {
			if (chr != keys.back()[0]) {
				q = 0;
				break;
			}
		}
		if (q) bad_chrs.insert(keys.back()[0]);
	}
	
	unordered_map<char, int> chrs;
	for (char i = 'a'; i < 'a' + e; i++) {
		if (bad_chrs.find(i) == bad_chrs.end()) chrs[i] = 0;
	}

	if (chrs.empty()) {
		cout << "NO";
		return 0;
	}

	char minChar = 'a';
	int minCount = INT_MAX;
	for (auto& chr : chrs) {
		for (auto& key : keys) {
			for (char k_ch : key) {
				if (k_ch == chr.first) chr.second++;
				else break;
			}
		}
		if (chr.second <= minCount) {
			minChar = chr.first;
			minCount = chr.second;
		}
	}
	for (int i = 0; i <= minCount; i++) {
		cout << minChar;
	}
}