
#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <cmath>
#include <algorithm>
#include <functional>
#include <bitset>
#include <climits>
#include <deque>
#include <queue>
#include <stack>
#include <random>
#include <valarray>
#include <iomanip>
#define ll long long
using namespace std;

int n;
vector<vector<int>> g;
vector<int> used;
vector<int> ans;
int k;

void dfs(int v) {
	used[v] = 1;
	for (size_t i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (used[to] == 0) {
			dfs(to);
		} else if (used[to] == 1) {
			++k;
		}
	}
	ans.push_back(v);
	used[v] = 2;
}

void topological_sort() {
	for (int i = 0; i < n; ++i) {
		used[i] = 0;
	}
	ans.clear();
	k = 0;
	for (int i = 0; i < n; ++i) {
		if (used[i] == 0) {
			dfs(i);
		}
	}
	
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		int m;
		cin >> n >> m;
		g = vector<vector<int>>(n, vector<int>());
		used = vector<int>(n);

		for (int i = 0; i < m; ++i) {
			int x, y;
			cin >> x >> y;
			--x; --y;
			g[x].push_back(y);
		}

		topological_sort();

		if (k > m - k) {
			for (auto x : ans) {
				cout << x + 1 << " ";
			}
		}
		else {
			reverse(ans.begin(), ans.end());
			for (auto x : ans) {
				cout << x + 1 << " ";
			}
		}
	}
	return 0;
}


