﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>

#define ll long long
#define vll vector<long long>
#define REP(i, s, n) for (size_t i = s; i < n; ++i)
#define VIN(v) for (auto &i : v) { cin >> i; }
using namespace std;

bool check_arr(vector<ll> a) {
	int n = a.size();
	for (int i = 0; i < n - 1; i++) {
		a[i + 1] -= a[i] * 2;
		a[i] = 0;
		if (a[i + 1] < 0) {
			return true;
		}
	}
	return false;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	ll t;
	cin >> t;
	for (int _ = 0; _ < t; _++) {
		ll min_i = -1;
		ll min_e = 1000000001;
		ll sum_a = 0;
		ll n;
		cin >> n;
		vector<ll> a(n);

		for (int i = 0; i < n; i++) {
			cin >> a[i];
			if (a[i] < min_e) {
				min_e = a[i];
				min_i = i;
			}

			sum_a += a[i];
		}

		sum_a -= min_e * n;
		
		if (sum_a % 3 && !(n % 3)) {
			cout << 0 << endl;
			continue;
		}

		int adj = 0;
		while (sum_a % 3) {
			sum_a += n;
			adj++;
		}

		min_e -= adj;
		min_e = max(min_e, 0ll);

		vector<ll> a2(n);
		for (int i = 0; i < n; i++) {
			a2[i] = a[(i + min_i) % n] - min_e;
		}


		if (adj != 2) {
			if (check_arr(a2)) {
				cout << 0 << endl;
			}
			else {
				cout << min_e << endl;
			}
		}
		else {
			if (check_arr(a2)) {
				a2[0] -= 2;
				a2[n - 1] -= 1;
				if (check_arr(a2)) {
					cout << 0 << endl;
				}
				else {
					cout << min_e << endl;
				}
			}
			else {
				cout << min_e << endl;
			}
		}
	}
}