#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <unordered_map>
#include <unordered_set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    scanf("%d", &t);
    for (int iter = 0; iter < t; ++iter) {
        int n;
        scanf("%d", &n);
        vector<pair<int, int>> arr(n);

        for (int i = 0; i < n; ++i) {
            scanf("%d", &arr[i].first);
        }
        for (int i = 0; i < n; ++i) {
            scanf("%d", &arr[i].second);
        }

        sort(arr.begin(), arr.end(), [](pair<int, int>& a, pair<int, int>& b){
            if (a.first == b.first) return a.second > b.second;
            return a.first < b.first;
        });

        long long answer = 0;
        bool flag = true;

        for (int j = 0; j < n; ++j) {
            if (arr[j].first < arr[j].second) {
                for (int k = j + 1; k < n; ++k) {
                    arr[k].second -= arr[j].second - arr[j].first;
                }
                answer += arr[j].second - arr[j].first;
                arr[j].second = arr[j].first;
            }
            else if (arr[j].first > arr[j].second) {
                flag = false;
                break;
            }
        }

        for (int j = 0; j < n; ++j)
            if (arr[j].first != arr[j].second) flag = false;
        if (flag) printf("%d\n", answer);
        else printf("%d\n", -1);
    }
}