#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include<bitset>
#include<cassert>
#include<random>

#define int long long
#define sigma signed
//#define double long double

using namespace std;

mt19937_64 rnd(87086040);

const int mod = 998'244'353;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> dp(n + 1, { 0, 0 });
    dp[1] = { 1, 1 };
    for (int i = 2; i <= n; i++) {
        dp[i].first = (dp[i - 1].first * 2 + dp[i - 1].second + 1) % mod;
        dp[i].second = (dp[i - 1].first + dp[i - 1].second * 2 + 1) % mod;
    }
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    while (a.size() && a.back() == b.back()) {
        a.pop_back();
        b.pop_back();
    }
    if (a.size() == 0) {
        cout << 0 << '\n';
        return;
    }
    int ans = 0;
    int pos = a[0];
    for (int i = 1; i < a.size() - 1; i++) {
        if (abs(pos - a[i]) == 2) {
            ans = (ans + dp[i].first + dp[i].second) % mod;
        }
        else {
            if (pos == 2) {
                ans = (ans + dp[i].second) % mod;
            } 
            else {
                ans = (ans + dp[i].first) % mod;
            }
        }
        pos = a[i];
    }
    vector<int> st[3];
    for (int i = 0; i < a.size() - 1; i++) {
        st[pos - 1].push_back(i);
    }
    if (a.back() != pos) {
        if (pos == 1) {
            if (a.back() == 2) {
                if (b.back() == 3) {
                    a.pop_back();
                    ans++;
                }
                else {
                    st[pos - 1].push_back(a.size() - 1);
                    swap(st[0], st[1]);
                    ans = (ans + dp[st[1].size() - 1].first) % mod;
                }
            }
            else {
                if (b.back() == 2) {
                    a.pop_back();
                    ans++;
                }
                else {
                    swap(st[0], st[1]);
                    st[1].push_back(a.size() - 1);
                    ans = (ans + 1 + dp[st[1].size() - 1].first) % mod;
                }
            }
        }
        else if (pos == 2) {
            if (a.back() == 1) {
                if (b.back() == 2) {
                    swap(st[1], st[2]);
                    a.pop_back();
                    ans = (ans + dp[st[2].size()].second + 1) % mod;
                }
                else {
                    ans = (ans + dp[st[1].size()].second + dp[st[1].size()].first + 1) % mod;
                    st[1].push_back(a.size() - 1);
                }
            }
            else {
                if (b.back() == 2) {
                    swap(st[1], st[0]);
                    a.pop_back();
                    ans = (ans + dp[st[0].size()].second + 1) % mod;
                }
                else {
                    ans = (ans + dp[st[1].size()].second + dp[st[1].size()].second + 1) % mod;
                    st[1].push_back(a.size() - 1);
                }
            }
        }
        else {
            if (a.back() == 2) {
                if (b.back() == 1) {
                    a.pop_back();
                    ans++;
                }
                else {
                    st[pos - 1].push_back(a.size() - 1);
                    swap(st[2], st[1]);
                    ans = (ans + dp[st[1].size() - 1].first) % mod;
                }
            }
            else {
                if (b.back() == 2) {
                    a.pop_back();
                    ans++;
                }
                else {
                    swap(st[2], st[1]);
                    st[1].push_back(a.size() - 1);
                    ans = (ans + 1 + dp[st[1].size() - 1].first) % mod;
                }
            }
        }
    }
    else {
        st[a.back() - 1].push_back(a.size() - 1);
    }
    int k = a.size();
    for (int i = k - 1; i >= 0; i--) {
        int pos;
        if (st[0].size() && st[0].back() == i) pos = 1;
        if (st[1].size() && st[1].back() == i) pos = 2;
        if (st[2].size() && st[2].back() == i) pos = 3;
        if (pos == 1) {
            if (b[i] == 1) {
                st[0].pop_back();
            }
            else if (b[i] == 2) {
                st[0].pop_back();
                swap(st[0], st[1]);
                swap(st[1], st[2]);
                ans = (ans + dp[i].first + dp[i].second + 1) % mod;
            }
            else {
                st[0].pop_back();
                ans = (ans + dp[i].first + dp[i].second + dp[i].first + dp[i].second + 2) % mod;
                swap(st[0], st[1]);
                swap(st[1], st[2]);
                swap(st[2], st[1]);
                swap(st[1], st[0]);
            }
        }
        else if (pos == 2) {
            if (b[i] == 1) {
                st[1].pop_back();
                ans = (ans + dp[i].second + 1) % mod;
                swap(st[1], st[2]);
            }
            else if (b[i] == 2) {
                st[1].pop_back();
            }
            else {
                st[1].pop_back();
                ans = (ans + dp[i].second + 1) % mod;
                swap(st[1], st[0]);
            }
        }
        else {
            if (b[i] == 1) {
                st[2].pop_back();
                ans = (ans + dp[i].first + dp[i].second + dp[i].first + dp[i].second + 2) % mod;
                swap(st[2], st[1]);
                swap(st[1], st[0]);
                swap(st[0], st[1]);
                swap(st[1], st[2]);
            }
            else if (b[i] == 2) {
                st[2].pop_back();
                ans = (ans + dp[i].first + dp[i].second + 1) % mod;
                swap(st[2], st[1]);
                swap(st[1], st[0]);
            }
            else {
                st[2].pop_back();
            }
        }
    }
    cout << ans % mod << '\n';
}

sigma main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLINE_JUDGE`

    int t = 1;
    cin >> t;

#ifdef LOCAL
    auto start = clock();
#endif // ONLINE_JUDGE
    while (t-- > 0) {
            solve();
    }
#ifdef LOCAL
    auto end = clock();

    cout << "\nWorking time: " << end - start << '\n';
    cout << "\nHUI\n";
#endif
}
