#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include<bitset>
#include<cassert>
#include<random>
#include <cstring>

#define int long long
#define sigma signed
//#define double long double

using namespace std;

mt19937_64 rnd(87086040);
const int mod = 998244353;

int binpow(int a, int b) {
	if (b == 0) return 1;

	if (b & 1) return binpow(a, b - 1) * a % mod;

	int x = binpow(a, b / 2);

	return x * x % mod;
}


struct MOD
{
	int x;

	MOD operator+=(MOD other) {
		x += other.x;
		if (x >= mod)
			x -= mod;

		return *this;
	}

	MOD operator-=(MOD other) {
		x -= other.x;
		if (x < 0)
			x += mod;

		return *this;
	}

	MOD operator*=(MOD other) {
		x *= other.x;
		x %= mod;


		return *this;
	}

	MOD operator/=(MOD other) {
		x *= binpow(other.x, mod - 2);
		x %= mod;

		return *this;
	}

	friend MOD operator+(MOD a, MOD b) {
		a += b;
		return a;
	}

	friend MOD operator-(MOD a, MOD b) {
		a -= b;
		return a;
	}

	friend MOD operator*(MOD a, MOD b) {
		a *= b;
		return a;
	}

	friend MOD operator/(MOD a, MOD b) {
		a /= b;
		return a;
	}


	MOD() { x = 0; }
	MOD(int y) : x(y) {
		x = (x % mod + mod) % mod;
	}
};
const int maxn = 105;

MOD help_dp[2][2][1 << 16][8];
MOD all_sum_n[1 << 16];
MOD all_sum_m[1 << 16];


int n, m, k;
string get(int chislo) {
    string help;
    for (int o = 0; o < k; ++o) {
        help += ((chislo >> o) & 1u) ? '1' : '0';
    }

    return help;
}

int get(string s) {
    int chislo = 0;
    reverse(s.begin(), s.end());
    for (auto now : s) {
        chislo *= 2;
        chislo += now - '0';
    }

    return chislo;
}

void solve() {
    cin >> n >> m >> k;

    string s;
    cin >> s;

	int x_x = get(s);

    for (int i = 0; i < (1 << k); ++i) {
        // preprelast, prelast, last
        string help = get(i);

        if (help == s) {
            help_dp[k & 1][1][0][i] = 1;
        }
        else {
            help_dp[k & 1][0][0][i] = 1;
        }
    }

	for (int i = k; i <= max(n, m); ++i) { // 100
		memset(help_dp[(i + 1) & 1], 0, sizeof(help_dp[(i + 1) & 1]));

		for (int zeroOne = 0; zeroOne <= 1; ++zeroOne) { // 2
			//cout << i << endl;
			for (int j = 0; j < (1 << (1 << (k + 1))); ++j) { // 2 ^ 16
				for (int u = 0; u < (1 << k); ++u) { // 8
					if(i == n && zeroOne == 1)
					all_sum_n[j] += help_dp[i & 1][zeroOne][j][u];

					if(i == m && zeroOne == 1)
					all_sum_m[j] += help_dp[i & 1][zeroOne][j][u];
					//string help = get(u); // 3

					//help += '0';

					int chislo = u;
					int mask = j | (1 << chislo);
					//help.erase(help.begin());

					if ((chislo >> 1) == x_x) {
						help_dp[(i + 1) & 1][1][mask][chislo >> 1]
							+= help_dp[i & 1][zeroOne][j][u];
					}
					else {
						help_dp[(i + 1) & 1][zeroOne][mask][chislo >> 1]
							+= help_dp[i & 1][zeroOne][j][u];
					}

					//help = get(u);
					//help += '1';

					chislo = u + (1 << k); // 3
					mask = j | (1 << chislo);
					//help.erase(help.begin());

					if ((chislo >> 1) == x_x) {
						help_dp[(i + 1) & 1][1][mask][chislo >> 1]
							+= help_dp[i & 1][zeroOne][j][u];
					}
					else {
						help_dp[(i + 1) & 1][zeroOne][mask][chislo >> 1]
							+= help_dp[i & 1][zeroOne][j][u];
					}
				}
			}
		}
	}

	MOD answer = 0;

	for (int i = 0; i < (1 << (1 << (k + 1))); ++i) {
		int mask = i ^ ((1 << (1 << (k + 1))) - 1);
		
		for (int j = mask; j; j = (j - 1) & mask) {
			answer += all_sum_n[i] * all_sum_m[j];
		}
	}

	cout << answer.x;
}

sigma main()
{
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLINE_JUDGE

    int t = 1;
    //cin >> t;

#ifdef LOCAL
    auto start = clock();
#endif // ONLINE_JUDGE
    while (t-- > 0) {
        solve();
    }
#ifdef LOCAL
    auto end = clock();

    cout << "\nWorking time: " << end - start << '\n';
    cout << "\nHUI\n";
#endif
}
